<?php
/***************************************************************
*  Copyright notice
*
*  (c) 2011 Tomasz Krawczyk <tomkrawc@gmail.com>
*  All rights reserved
*
*  This script is part of the TYPO3 project. The TYPO3 project is
*  free software; you can redistribute it and/or modify
*  it under the terms of the GNU General Public License as published by
*  the Free Software Foundation; either version 2 of the License, or
*  (at your option) any later version.
*
*  The GNU General Public License can be found at
*  http://www.gnu.org/copyleft/gpl.html.
*
*  This script is distributed in the hope that it will be useful,
*  but WITHOUT ANY WARRANTY; without even the implied warranty of
*  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
*  GNU General Public License for more details.
*
*  This copyright notice MUST APPEAR in all copies of the script!
***************************************************************/
/**
 * [CLASS/FUNCTION INDEX of SCRIPT]
 *
 * Hint: use extdeveval to insert/update function index above.
 */

require_once(PATH_tslib.'class.tslib_pibase.php');


/**
 * Plugin 'Table for Connector SQL' for the 'tk_svconsql_table' extension.
 *
 * @author	Tomasz Krawczyk <tomkrawc@gmail.com>
 * @package	TYPO3
 * @subpackage	tx_tksvconsqltable
 */
class tx_tksvconsqltable_pi1 extends tslib_pibase {
	var $prefixId      = 'tx_tksvconsqltable_pi1';		// Same as class name
	var $scriptRelPath = 'pi1/class.tx_tksvconsqltable_pi1.php';	// Path to this script relative to the extension dir.
	var $extKey        = 'tk_svconsql_table';	// The extension key.
	
	var $formats = Array('string', 'int', 'dec', 'date', 'time');
	var $sqlParams;
	var $tableParams;
	var $fmtParams;
	
	
	function printError($content) {	
		$strContent = '<div class="errorMsg">' . $content . '</div>';
		return $this->pi_wrapInBaseClass($strContent);
	}

	
	function getTSConfig() {
		
		$this->fmtParams['dateFormat'] = $this->conf['dateFormat'];
		$this->fmtParams['timeFormat'] = $this->conf['timeFormat'];
		$this->fmtParams['decimals'] = $this->conf['decimals'];
		$this->fmtParams['dec_point'] = $this->conf['dec_point'];
		
		if( strcasecmp($this->conf['thousands_sep'], 'space') !== 0 )
			$this->fmtParams['thousands_sep'] = $this->conf['thousands_sep'];
		else
			$this->fmtParams['thousands_sep'] = ' ';
				
		$sqlConf = $this->conf['db.'];
		$this->sqlParams = array(
			'driver' => $sqlConf['driver'],
			'server' => $sqlConf['server'],
			'user' => $sqlConf['user'],
			'password' => $sqlConf['password'],
			'database' => $sqlConf['database'],
			'query' => $sqlConf['query']
		);
		
		$tabConf = $this->conf['table.'];
		$this->tableParams = array(
			'cellPadding' => $tabConf['cellPadding'],
			'cellSpacing' => $tabConf['cellSpacing'],
			'class' => $tabConf['class'],
			'caption' => $tabConf['caption'],
			'colNames' => $tabConf['colNames'],
			'colFormats' => $tabConf['colFormats'],
			'hiddenCols' => $tabConf['hiddenCols'],
			'rowClasses' => $tabConf['rowClasses'],
			'colClasses' => $tabConf['colClasses'],
			'captionInFirstCol' => $tabConf['captionInFirstCol']
		);
	}
	
	
	function getFFconfig() {

		$sTemp = $this->pi_getFFvalue( $this->cObj->data['pi_flexform'], 'dFriver', 'sDEF');
		if( sTemp !== '' )
			$this->sqlParams['driver'] = $sTemp;
		
		$sTemp = $this->pi_getFFvalue( $this->cObj->data['pi_flexform'], 'fServer', 'sDEF');
		if( $sTemp !== '' ) 
			$this->sqlParams['server'] = $sTemp;
			
		$sTemp = $this->pi_getFFvalue( $this->cObj->data['pi_flexform'], 'fUser', 'sDEF');
		if( $sTemp !== '' ) 
			$this->sqlParams['user'] = $sTemp;
			
		$sTemp = $this->pi_getFFvalue( $this->cObj->data['pi_flexform'], 'fPassword', 'sDEF');
		if( $sTemp !== '' ) 
			$this->sqlParams['password'] = $sTemp;
			
		$sTemp = $this->pi_getFFvalue( $this->cObj->data['pi_flexform'], 'fDatabase', 'sDEF');
		if( $sTemp !== '' )
			$this->sqlParams['database'] = $sTemp;
			
		$sTemp = $this->pi_getFFvalue( $this->cObj->data['pi_flexform'], 'fQuery', 'sDEF');
		if( $sTemp !== '' )
			$this->sqlParams['query'] = $sTemp;

			
		// Read FlexForms database values
		$sTemp = $this->pi_getFFvalue( $this->cObj->data['pi_flexform'], 'fCellpadding', 'sTable');
		if( $sTemp !== '' )
			$this->tableParams['cellPadding'] = $sTemp;
			
		$sTemp = $this->pi_getFFvalue( $this->cObj->data['pi_flexform'], 'fCellspacing', 'sTable');
		if( $sTemp !== '' )
			$this->tableParams['cellSpacing'] = $sTemp;
		
		$sTemp = $this->pi_getFFvalue( $this->cObj->data['pi_flexform'], 'fClass', 'sTable');
		if( $sTemp !== '' )
			$this->tableParams['class'] = $sTemp;
			
		$sTemp = $this->pi_getFFvalue( $this->cObj->data['pi_flexform'], 'fCaption', 'sTable');
		if( $sTemp !== '' )
			$this->tableParams['caption'] = $sTemp;
			
		$sTemp = $this->pi_getFFvalue( $this->cObj->data['pi_flexform'], 'fColnames', 'sTable');
		if( $sTemp !== '' )
			$this->tableParams['colNames'] = $sTemp;
			
		$sTemp = $this->pi_getFFvalue( $this->cObj->data['pi_flexform'], 'fColFormats', 'sTable');
		if( $sTemp !== '' )
			$this->tableParams['colFormats'] = $sTemp;
			
		$sTemp = $this->pi_getFFvalue( $this->cObj->data['pi_flexform'], 'fHiddencols', 'sTable');
		if( $sTemp !== '' )
			$this->tableParams['hiddenCols'] = $sTemp;
		
		$sTemp = $this->pi_getFFvalue( $this->cObj->data['pi_flexform'], 'fRowclasses', 'sTable');
		if( $sTemp !== '' )
			$this->tableParams['rowClasses'] = $sTemp;
			
		$sTemp = $this->pi_getFFvalue( $this->cObj->data['pi_flexform'], 'fColclasses', 'sTable');
		if( $sTemp !== '' )
			$this->tableParams['colClasses'] = $sTemp;
		
		$sTemp = $this->pi_getFFvalue( $this->cObj->data['pi_flexform'], 'fCFirstcol', 'sTable');
		if( $sTemp !== '' )
			$this->tableParams['captionInFirstCol'] = $sTemp;
	}
	
	
	function init($conf) {
		
		$this->conf = $conf;
		$this->pi_setPiVarDefaults();
		$this->pi_initPIflexForm();
		$this->pi_loadLL();
		$this->pi_USER_INT_obj = 0;	// Configuring so caching is not expected. This value means that no cHash params are ever set. We do this, because it's a USER_INT object!

		// Read TS config
		$this->getTSConfig();

		// Read FlexForms config
		$this->getFFconfig();
	}
	

	function formatOutput($sFormatName, $sValue) {
	
		switch($sFormatName)
		{
			case 'int':
				$sRes = number_format( intval($sValue),
							0, 
							$this->fmtParams['dec_point'], 
							$this->fmtParams['thousands_sep']);
				break;
				
			case 'dec':
				$sRes = number_format( floatval($sValue),
							$this->fmtParams['decimals'], 
							$this->fmtParams['dec_point'], 
							$this->fmtParams['thousands_sep']);
				break;
			
			case 'date':
				$sRes = date($this->fmtParams['dateFormat'], $sValue);
				break;

			case 'time':
				$sRes = date($this->fmtParams['timeFormat'], $sValue);
				break;
			
			default:
				$sRes = htmlspecialchars($sValue);
				break;
		};
		
		return $sRes;
	}
	
	
	/**
	 * The main method of the PlugIn
	 *
	 * @param	string		$content: The PlugIn content
	 * @param	array		$conf: The PlugIn configuration
	 * @return	The content that is displayed on the website
	 */
	function main($content, $conf) {
		
		$this->init($conf);
		
		$intCellPadding = intval($this->tableParams['cellPadding']);
		$intCellSpacing = intval($this->tableParams['cellSpacing']);

		$strClass = trim($this->tableParams['class']);
		$strCaption = trim($this->tableParams['caption']);
		
		$arColNames = explode(',', $this->tableParams['colNames']);		
		$nCols = count($arColNames);
		
		$arTmp = explode(',', $this->tableParams['colFormats']);
		for($i = 0; $i < count($arTmp); $i++) {
			if( in_array($arTmp[$i], $this->formats) ) {
				$arColFormats[] = $arTmp[$i];
			} else {
				$arColFormats[] = 'string';
			}
		}
		
		$nFmts = count($arColFormats);		
		if( $nFmts != $nCols )
			return $this->printError( $this->pi_getLL('amount_cols_n_formats') );
		
		$arHiddenCols = explode(',', $this->tableParams['hiddenCols']);
		$nHiddenCols = count($arHiddenCols);		

		$arRowClasses = explode(',', $this->tableParams['rowClasses']);
		$nRowClasses = count($arRowClasses);
		
		$arColClasses = explode(',', $this->tableParams['colClasses']);
		$nColClasses = count($arColClasses);
		
		$intCaptionInFirstCol = intval($this->tableParams['captionInFirstCol']);
		$bCaptionTaken = false;

		//print_r($this->internal);

		// Check SQL params
		if ($this->sqlParams['driver'] == '' )
			return $this->printError( $this->pi_getLL('no_db_driver_set') );

		if ($this->sqlParams['server'] == '' )
			return $this->printError( $this->pi_getLL('no_db_server_set') );

		if ($this->sqlParams['user'] == '' )
			return $this->printError( $this->pi_getLL('no_db_user_set') );

		if ($this->sqlParams['password'] == '' )
			return $this->printError( $this->pi_getLL('no_db_password_set') );

		if ($this->sqlParams['database'] == '' )
			return $this->printError( $this->pi_getLL('no_db_database_set') );

		if ($this->sqlParams['query'] == '' )
			return $this->printError( $this->pi_getLL('no_db_query_set') );


		// Connect to service
		$services = t3lib_extMgm::findService('connector', 'sql');
		if ($services === FALSE) {
			return $this->printError( $this->pi_getLL('no_svconnector_sql') );
		} else {
			$connector = t3lib_div::makeInstanceService('connector', 'sql');
		}


		// Get data from external database
		$data = $connector->fetchArray($this->sqlParams);
		$nRows = count($data);


		// Build table
		$tBegin = '<table';
		$tBegin .= ' cellpadding="' . $intCellPadding . '"';
		$tBegin .= ' cellspacing="' . $intCellSpacing . '"';
		$tBegin .= ($strClass == '' ? '>' : ' class="' . $strClass . '">');
		
		
		// table caption
		$tCaption = ($strCaption == '' ? '' : '<caption>' . $strCaption . '</caption>');

		
		// table header
		if( $nCols > 0 ) {
		
			$tHead = '<thead><tr>';
			
			if( $nHiddenCols > 0 ) {
			
				for($i = 0; $i < $nCols; $i++) {				
					// Skip hidden column headers
					if( !in_array($arColNames[$i], $arHiddenCols) )
						$tHead .= '<th>' . $arColNames[$i] . '</th>';
				}
			} else {
				for($i = 0; $i < $nCols; $i++)
					$tHead .= '<th>' . $arColNames[$i] . '</th>';
			}
			$tHead .= '</tr></thead>';
		}
		
		
		// table body
		$tBody = '<tbody>';		
		if( $nRows > 0 ) {
			
			for($j = 0; $j < $nRows; $j++) {
				
				if( $nRowClasses > 0 ) {
					$strRowClass = $arRowClasses[$j % $nRowClasses];
					$tBody .= ($strRowClass == '' ? '<tr>' : '<tr class="' . $strRowClass . '">');
				} else {
					$tBody .= '<tr>';
				}
				
				$row = $data[$j];				
				
				foreach($row as $key => $value) {
					
					// take caption from first col
					if( $intCaptionInFirstCol == 1 ) {					
						
						if( !$bCaptionTaken) {							
							$strCaption = $this->formatOutput($arColFormats[$key], $value);
							$tCaption = ($strCaption == '' ? '' : '<caption>' . $strCaption . '</caption>');
							$bCaptionTaken = true;
						}
					}
				
					// Skip hidden columns
					if( !in_array($arColNames[$key], $arHiddenCols) ) {
						
						if( $nColClasses > 0 ) {
							$strColClass = $arColClasses[$key % $nColClasses];
							$tBody .= ($strColClass == '' ? '<td>' : '<td class="' . $strColClass . '">');							
							$tBody .= $this->formatOutput($arColFormats[$key], $value);							
							$tBody .= '</td>';
							
						} else {
							$tBody .= '<td>' . htmlspecialchars($value) . '</td>';
						}
					}

				}
				$tBody .= '</tr>';
			}

		} else {
			$tBody .= '<tr>'. $this->pi_getLL('no_records') . '</tr>';
		}
		
		$tBody .= '</tbody>';		
		$tEnd = '</table>';		
		
		$content = $tBegin . $tCaption . $tHead . $tBody . $tEnd;

		return $this->pi_wrapInBaseClass($content);
	}
}



if (defined('TYPO3_MODE') && $TYPO3_CONF_VARS[TYPO3_MODE]['XCLASS']['ext/tk_svconsql_table/pi1/class.tx_tksvconsqltable_pi1.php'])	{
	include_once($TYPO3_CONF_VARS[TYPO3_MODE]['XCLASS']['ext/tk_svconsql_table/pi1/class.tx_tksvconsqltable_pi1.php']);
}

?>